/*

Copyright 2001 
by Constantin Loizides <constantin.loizides@isg.de>


This file is part of the journaling-filesystem fragmentation project.
You find the files belonging to that project in the Makefile
coming together with this file.

Source code concerning that project is free software; 
you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  
USA

*/


#ifndef cl_time_h
#define cl_time_h

#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <errno.h>

#define min(X,Y) ((X) < (Y) ? (X) : (Y))
#define max(X,Y) ((X) > (Y) ? (X) : (Y))

#define MinTime (0.5)
#define TIMEVAL_TO_DOUBLE(X) (double((X).tv_sec) + double((X).tv_usec) / 1000000.0)
#define CHECK_BOUNDS(X) if((X<0)||(X>=TestCount)) return;

/* 
   most of this class is taken from bonnie++ and
   changed to what I need				

   see http://www.coker.com.au/bonnie++/
   for the original version of the timer class
*/

class cl_Timer
{
	struct report_s
	{
		double CPU;
		double StartTime;
		double EndTime;
	};

	struct delta_s
	{
		double CPU;
		double Elapsed;
		double FirstStart;
		double LastStop;
		unsigned long long counter;

/*
		unsigned long long swaps;
		unsigned long long inblocks;
		unsigned long long outblocks;
*/
	};

	public:
		enum RepType {csv,txt};
		cl_Timer(int T_=1);
		~cl_Timer();
		void initialize();
		void timestamp();
		void get_delta_t(int test=0,unsigned long long add=0);
#ifdef notnow
		void get_delta_report(report_s &rep);
		void add_delta_report(report_s &rep,int test);
#endif
		double cpu_so_far();
		double time_so_far();
		static double get_cur_time();
		static double get_cpu_use();
		void print_cpu_stat(int test=0,FILE *m_fp=stdout);
		void print_time_stat(int test=0,FILE *m_fp=stdout);
		void print_stat(int test=0,FILE *m_fp=stdout);
		void SetType(RepType type){m_type=type;}
	private:
		int TestCount;
		delta_s *m_delta;
		double m_last_cpustamp;
		double m_last_timestamp;
/*
		long m_last_swaps_stamp;
		long m_last_inblocks_stamp;
		long m_last_outblock_stamp;
*/
		RepType m_type;
};

#endif
